(function ($, _, Backbone, app) {
    app.models.section = Backbone.Model.extend({
        defaults: {
            title: '—',
            id: ''
        }
    });

    app.models.sections = Backbone.Collection.extend({
        model: app.models.section
    });

    app.models.post = Backbone.Model.extend({
        initialize: function () {
            this.set('images', new app.models.images(this.get('images')));
            this.set('sections', new app.models.sections(this.get('sections')));
            this.set('participantBlocks', new app.models.participantBlocks(this.get('participantBlocks')));
        }
    });

    app.models.posts = Backbone.Collection.extend({
        url: '/control/articles/',

        model: app.models.post,
        parse: function (data) {
            return data;
        }
    });

    app.models.tag = Backbone.Model.extend({});

    app.models.tags = Backbone.Collection.extend({
        model: app.models.tag
    });

    app.models.image = Backbone.Model.extend({});

    app.models.images = Backbone.Collection.extend({
        model: app.models.image
    });

    app.models.pageType = Backbone.Model.extend({
        initialize: function () {
            this.set('blockTypes', new app.models.blockTypes(this.get('blockTypes')));
        }
    });

    app.models.pageTypes = Backbone.Collection.extend({
        model: app.models.pageType,
        parse: function (data) {
            return data;
        }
    });

    app.models.blockType = Backbone.Model.extend({
        initialize: function () {
            this.set('columnTypes', new app.models.blockTypes(this.get('columnTypes')));
        }
    });

    app.models.blockTypes = Backbone.Collection.extend({
        model: app.models.blockType,
        parse: function (data) {
            return data;
        }
    });

    app.models.columnType = Backbone.Model.extend({});

    app.models.columnTypes = Backbone.Collection.extend({
        model: app.models.columnType,
        parse: function (data) {
            return data;
        }
    });

    app.models.participant = Backbone.Model.extend({});

    app.models.participants = Backbone.Collection.extend({
        model: app.models.participant
    });

    app.models.participantBlock = Backbone.Model.extend({
        initialize: function () {
            this.set('participants', new app.models.participants(this.get('participants')));
        }
    });

    app.models.participantBlocks = Backbone.Collection.extend({
        model: app.models.participantBlock,
        parse: function (data) {
            return data;
        }
    });

    Backbone.Model.prototype.toJSON = function () {
        var json = _.clone(this.attributes);
        for (var attr in json) {
            if ((json[attr] instanceof Backbone.Model) || (json[attr] instanceof Backbone.Collection)) {
                json[attr] = json[attr].toJSON();
            }
        }
        return json;
    };

}(jQuery, _, Backbone, application));