if (typeof Controls == 'undefined')
    var Controls = {};

// correct handles for resize and scroll
var windowResized = null, windowScrolled = null, scrollPosition = window.pageYOffset, tabClicked = null;
$(window).bind('resize', function(event) {
    window.clearTimeout(windowResized);
    windowResized = window.setTimeout(function(){
        $(window).trigger('resized');
    }, 500);
});
$(window).bind('scroll', function (event) {
    ( detectDirection() == 'up' ) ? $('html').addClass('scrolled-up').removeClass('scrolled-down') : $('html').removeClass('scrolled-up').addClass('scrolled-down');
    window.clearTimeout(windowScrolled);
    windowScrolled = window.setTimeout(function(){
        $(window).trigger('scrolled');
    }, 5);
});

// scroll direction
function detectDirection() {
    var direction = (window.pageYOffset > scrollPosition) ? 'down' : 'up';
    scrollPosition = window.pageYOffset;
    //_console(direction);
    return direction;
}

// console output
function _console(html) {
    if ( !$('#console').length )
        $('body:eq(0)').append('<div id="console" style="display: block;z-index: 99999999;position: fixed;background-color:#000;color:#fff;padding:10px;top: 0;left: 0;"></div>');
    if ( typeof(html) == 'object' ) {
        var acc = [];
        $.each(html, function(index, value) {
            acc.push(index + ': ' + value + '<hr/>');
        });
        $('#console').css('position', 'absolute').html( JSON.stringify(acc) );
    }
    else
        $('#console').html( html );
}

// debug object
function _debug(object){

    if ( typeof object == 'undefined' )
        alert( 'undefined' );
    else
    if ( object == null )
        alert( 'null' );
    else {
        var acc = [];
        $.each(object, function(index, value) {
            acc.push(index + ': ' + value);
        });
        alert(JSON.stringify(acc));
    }
}

$(document).ready(function(){

    // табы
    $('[data-toggle="tab"]')
        .on('mouseover', function(){
            if ( $(this).is('.disabled') )
                return false;
            else
                if ( $(this).is('[data-activate="hover"]:not(.active)') ){
                    $(this).tab('show');
                }
        })
        .on('click', function(event){

            //event.preventDefault();

            var tab = $(this);

            if ( tab.is('.disabled') )
                return false;
            else
                if ( tab.is('.active') && tab.attr('href') )
                    document.location = tab.attr('href');

            if ( tab.is('.active') ) return false;

        })
        .on('show.bs.tab', function(){
            $(this).siblings('[data-toggle="tab"]').removeClass('active');
            $(this).addClass('active');
        })
        .on('shown.bs.tab', function (){
            $(window).trigger('resized');
        })
        .on('hide.bs.tab', function (){
        })
        .on('hidden.bs.tab', function (){
        })
    ;

    // листалки
    $('[data-slider="true"]:not(.is-ready)').each(function(index, slider){
        new Controls.slider( $(slider) );
    });

    // перевод img в inline svg
    $('img.svg2inline[src$=".svg"]').each(function() {
        var $img = jQuery(this);
        var imgURL = $img.attr('src');
        var attributes = $img.prop("attributes");
        $.get(imgURL, function(data) {
            var $svg = jQuery(data).find('svg');
            $svg = $svg.removeAttr('xmlns:a');
            $.each(attributes, function() {
                $svg.attr(this.name, this.value);
            });
            $img.replaceWith($svg);
        }, 'xml');
    });

});

Controls.slider = function( slider ) {
    if (!slider.length)
        return;
    this.init(slider);
};

Controls.slider.prototype = {

    init: function(slider) {

        var item = this;
        this.slider = slider;
        this.slider_content = this.slider.find('.slider-content');
        this.slider_items = this.slider.find('.slides');
        this.active = this.slider_items.find('.active').index() || 0;

        // обертка
        if ( !slider.find('.slider-content').length )
            slider.wrapInner('<div class="slider-content"></div>');

        // стрелки
        if ( slider.data('arrows') && !slider.find('.arrow').length  && item.slider_items.children().length > 1 )
            slider.append('<a class="click arrow left prev">&larr;</a><a class="click arrow right next">&rarr;</a>');

        // пагинатор
        if ( slider.data('pager') && !slider.find('.pager').length && item.slider_items.children().length > 1 )
            item.pager = $('<ul class="pager"></ul>').appendTo( ( slider.data('pager') == 'inside' ? slider : slider.parent() ) );

        // обновление ширины слайдов-колонок
        if ( item.slider.data('cols') )
            item.slider.find('.slide').width( item.slider_content.width() / parseInt(item.slider.data('cols'), 10) );

        // запуск
        this.slider_content
            .sly(false)
            .sly({
                horizontal: 1,
                itemNav: ( slider.data('center') ) ? 'forceCentered' : 'centered',
                smart: 1,
                activateOn: 'click', //null
                activateMiddle: 1,
                mouseDragging: 1,
                touchDragging: 1,
                releaseSwing: 1,
                scrollBar: 0,
                scrollBy: 0,
                scrollTrap: false,
                scrollSource: null,
                pagesBar: item.pager,
                activatePageOn: 'click',
                elasticBounds: 1,
                dragHandle: 1,
                dynamicHandle: 1,
                clickBar: 0,

                cycleBy: ( slider.data('autoplay') ) ? 'items' : null,
                cycleInterval: ( slider.data('autoplay') ) ? 2000 : null,
                pauseOnHover: true,
                startPaused: false,

                moveBy: 1000,
                speed: 500,
                easing: 'easeOutExpo',
                startAt: 0,
                keyboardNavBy: null,

                // buttons
                forward: slider.find('.forward'),
                backward: slider.find('.backward'),
                prev: slider.find('.prev'),
                next: slider.find('.next'),
                prevPage: slider.find('.prevPage'),
                nextPage: slider.find('.nextPage')
            },
            {
                active: function(eventName, itemIndex){
                    slider.find('.slide').removeClass('beforeActive afterActive');
                    var slide = item.slider_items.find('>*:eq('+itemIndex+')');
                    slide.prev().addClass('beforeActive');
                    slide.next().addClass('afterActive');
                    // открываем соотв. вкладку при смене слайда
                    if ( slide.is('.active[data-toggle="tab"]') )
                        slide.tab('show');
                }
            }
        ).sly('activate', this.active, true); // запуск

        // обновляем размеры при загрузке/ресайзе
        $(window).bind('load', item, item.update); //&resized

        // обнуляем клик по слайду
        //item.slider_items.find('> .slide').on('click', function(event){ event.preventDefault(); });
    },

    update: function( params ){
        var item = params.data;
        // обновление ширины слайдов-колонок
        if ( item.slider.data('cols') )
            item.slider.find('.slide').width( item.slider_content.width() / parseInt(item.slider.data('cols'), 10) );

        item.slider.addClass('is-ready');
    }

};